Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# ShaderAttrib Class Reference

Inheritance diagram for ShaderAttrib:

List of all members.

## Public Member Functions
bool | autoGlossOn ()
bool | autoGlowOn ()
bool | autoNormalOn ()
bool | autoRampOn ()
bool | autoShader ()
| If true, then this ShaderAttrib does not contain an explicit shader - instead, it requests the automatic generation of a shader.
bool | autoShadowOn ()
RenderAttrib const | clearAllShaderInputs ()
| Clears all the shader inputs on the attrib.
RenderAttrib const | clearFlag (int flag)
RenderAttrib const | clearShader ()
RenderAttrib const | clearShaderInput (InternalName const id)
RenderAttrib const | clearShaderInput (string id)
bool | getFlag (int flag)
int | getInstanceCount ()
| Returns the number of geometry instances.
Shader const | getShader ()
| Returns the shader object associated with the node.
ShaderInput const | getShaderInput (string id)
| Returns the ShaderInput of the given name.
ShaderInput const | getShaderInput (InternalName const id)
| Returns the ShaderInput of the given name.
NodePath const | getShaderInputNodepath (InternalName const id)
| Returns the ShaderInput as a nodepath.
ShaderPtrData const | getShaderInputPtr (InternalName const id)
| Returns the ShaderInput as a ShaderPtrData struct.
Texture | getShaderInputTexture (InternalName const id)
| Returns the ShaderInput as a texture.
VBase4 const | getShaderInputVector (InternalName id)
| Returns the ShaderInput as a vector.
int | getShaderPriority ()
bool | hasShader ()
| If true, the shader field of this attribute overrides the shader field of the parent attribute.
RenderAttrib const | setFlag (int flag, bool value)
RenderAttrib const | setInstanceCount (int instance_count)
| Sets the geometry instance count.
RenderAttrib const | setShader (Shader const s, int priority)
RenderAttrib const | setShader (Shader const s)
RenderAttrib const | setShaderAuto ()
RenderAttrib const | setShaderAuto (int priority)
RenderAttrib const | setShaderAuto (BitMaskunsigned int, 32 shader_switch, int priority)
| Set auto shader with bitmask to customize use, e.g., to keep normal, glow, etc., on or off.
RenderAttrib const | setShaderAuto (BitMaskunsigned int, 32 shader_switch)
| Set auto shader with bitmask to customize use, e.g., to keep normal, glow, etc., on or off.
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayUnalignedLMatrix4f const v)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayUnalignedLMatrix4f const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayVBase3 const v)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayVBase3 const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayVBase2 const v)
RenderAttrib const | setShaderInput (InternalName const id, VBase4 const v)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArraydouble const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, NodePath const np, int priority)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayMat3 const v, int priority)
RenderAttrib const | setShaderInput (ShaderInput const inp)
RenderAttrib const | setShaderInput (InternalName const id, VBase3 const v)
RenderAttrib const | setShaderInput (InternalName const id, double n1, double n2, double n3)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArraydouble const v)
RenderAttrib const | setShaderInput (InternalName const id, VBase3 const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, double n1, double n2, double n3, double n4)
RenderAttrib const | setShaderInput (InternalName const id, VBase2 const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, Mat4 const v)
RenderAttrib const | setShaderInput (InternalName const id, Mat4 const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, Mat3 const v)
RenderAttrib const | setShaderInput (InternalName const id, Mat3 const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayMat3 const v)
RenderAttrib const | setShaderInput (InternalName const id, double n1, double n2)
RenderAttrib const | setShaderInput (InternalName const id, VBase4 const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayVBase2 const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, Texture tex, int priority)
RenderAttrib const | setShaderInput (InternalName const id)
RenderAttrib const | setShaderInput (InternalName const id, VBase2 const v)
RenderAttrib const | setShaderInput (InternalName const id, double n1, double n2, double n3, double n4, int priority)
RenderAttrib const | setShaderInput (InternalName const id, NodePath const np)
RenderAttrib const | setShaderInput (InternalName const id, double n1)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayfloat const v, int priority)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayUnalignedLVecBase4f const v)
RenderAttrib const | setShaderInput (InternalName const id, Texture tex)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayfloat const v)
RenderAttrib const | setShaderInput (InternalName const id, PointerToArrayUnalignedLVecBase4f const v, int priority)
RenderAttrib const | setShaderOff ()
RenderAttrib const | setShaderOff (int priority)
## Static Public Member Functions
static int | getClassSlot ()
static TypeHandle | getClassType ()
static RenderAttrib const | make ()
| Constructs a new ShaderAttrib object with nothing set.
static RenderAttrib const | makeDefault ()
| Returns a RenderAttrib that corresponds to whatever the standard default properties for render attributes of this type ought to be.
static RenderAttrib const | makeOff ()
| Constructs a new ShaderAttrib object that disables the use of shaders (it does not clear out all shader data, however.)
static | registerWithReadFactory ()
| Factory method to generate a Shader object.

## Member Function Documentation

bool autoGlossOn | ( |  | ) |

bool autoGlowOn | ( |  | ) |

bool autoNormalOn | ( |  | ) |

bool autoRampOn | ( |  | ) |

bool autoShader | ( |  | ) |

If true, then this ShaderAttrib does not contain an explicit shader - instead, it requests the automatic generation of a shader.

bool autoShadowOn | ( |  | ) |

RenderAttrib const clearAllShaderInputs | ( |  | ) |

Clears all the shader inputs on the attrib.

RenderAttrib const clearFlag | ( | int | flag | ) |

RenderAttrib const clearShader | ( |  | ) |

RenderAttrib const clearShaderInput | ( | string | id | ) |

RenderAttrib const clearShaderInput | ( | InternalName const | id | ) |

static int getClassSlot | ( |  | ) | `[static]`

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from RenderAttrib.

bool getFlag | ( | int | flag | ) |

int getInstanceCount | ( |  | ) |

Returns the number of geometry instances.

A value of 0 means not to use instancing at all.

Shader const getShader | ( |  | ) |

Returns the shader object associated with the node.

If get_override returns true, but get_shader returns NULL, that means that this attribute should disable the shader.

ShaderInput const getShaderInput | ( | InternalName const | id | ) |

Returns the ShaderInput of the given name.

If no such name is found, this function does not return NULL --- it returns the "blank" ShaderInput.

ShaderInput const getShaderInput | ( | string | id | ) |

Returns the ShaderInput of the given name.

If no such name is found, this function does not return NULL --- it returns the "blank" ShaderInput.

NodePath const getShaderInputNodepath | ( | InternalName const | id | ) |

Returns the ShaderInput as a nodepath.

Assertion fails if there is none, or if it is not a nodepath.

ShaderPtrData const getShaderInputPtr | ( | InternalName const | id | ) |

Returns the ShaderInput as a ShaderPtrData struct.

Assertion fails if there is none. or if it is not a PTA(double/float)

Texture getShaderInputTexture | ( | InternalName const | id | ) |

Returns the ShaderInput as a texture.

Assertion fails if there is none, or if it is not a texture.

VBase4 const getShaderInputVector | ( | InternalName | id | ) |

Returns the ShaderInput as a vector.

Assertion fails if there is none, or if it is not a vector.

int getShaderPriority | ( |  | ) |

bool hasShader | ( |  | ) |

If true, the shader field of this attribute overrides the shader field of the parent attribute.

static RenderAttrib const make | ( |  | ) | `[static]`

Constructs a new ShaderAttrib object with nothing set.

static RenderAttrib const makeDefault | ( |  | ) | `[static]`

Returns a RenderAttrib that corresponds to whatever the standard default properties for render attributes of this type ought to be.

static RenderAttrib const makeOff | ( |  | ) | `[static]`

Constructs a new ShaderAttrib object that disables the use of shaders (it does not clear out all shader data, however.)

static registerWithReadFactory | ( |  | ) | `[static]`

Factory method to generate a Shader object.

RenderAttrib const setFlag | ( | int | flag,
|  | bool | value
| ) |  |

RenderAttrib const setInstanceCount | ( | int | instance_count | ) |

Sets the geometry instance count.

Do not confuse this with instanceTo, which is used for animation instancing, and has nothing to do with this. A value of 0 means not to use instancing at all.

RenderAttrib const setShader | ( | Shader const | s,
|  | int | priority
| ) |  |

RenderAttrib const setShader | ( | Shader const | s | ) |

RenderAttrib const setShaderAuto | ( | int | priority | ) |

RenderAttrib const setShaderAuto | ( |  | ) |

RenderAttrib const setShaderAuto | ( | BitMaskunsigned | int,
|  | 32 | shader_switch
| ) |  |

Set auto shader with bitmask to customize use, e.g., to keep normal, glow, etc., on or off.

RenderAttrib const setShaderAuto | ( | BitMaskunsigned | int,
|  | 32 | shader_switch,
|  | int | priority
| ) |  |

Set auto shader with bitmask to customize use, e.g., to keep normal, glow, etc., on or off.

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayVBase3 const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayVBase2 const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayUnalignedLMatrix4f const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayfloat const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | VBase3 const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | double | n1,
|  | double | n2
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id | ) |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | NodePath const | np,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | VBase4 const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | ShaderInput const | inp | ) |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | Texture | tex
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | VBase2 const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | VBase2 const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | Mat4 const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | Texture | tex,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | Mat3 const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | Mat3 const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayVBase2 const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayMat3 const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | double | n1,
|  | double | n2,
|  | double | n3,
|  | double | n4,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | NodePath const | np
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | VBase4 const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayMat3 const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArraydouble const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayfloat const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | double | n1,
|  | double | n2,
|  | double | n3
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | Mat4 const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayUnalignedLVecBase4f const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | double | n1,
|  | double | n2,
|  | double | n3,
|  | double | n4
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | VBase3 const | v,
|  | int | priority
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | double | n1
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayUnalignedLVecBase4f const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArraydouble const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayUnalignedLMatrix4f const | v
| ) |  |

RenderAttrib const setShaderInput | ( | InternalName const | id,
|  | PointerToArrayVBase3 const | v
| ) |  |

RenderAttrib const setShaderOff | ( | int | priority | ) |

RenderAttrib const setShaderOff | ( |  | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties